// @abstract(Level Cell for RL Core)
// @author(Kornel Kisielewicz <kisiel@fulbrightweb.org>)
// @created(March 6, 2005)
// @lastmod(March 6, 2005)
//
// This unit hold's cell data;

unit rlcell;
interface
uses vutil;

const MaxCells = 250;

type TCellData = record
       color   : Byte;
       pic     : char;
       pass    : boolean;
       bvis    : boolean;
       canch   : boolean;
       actto   : byte;
       special : byte;
       id      : string[20];
       name    : string[30];
     end;
     
     
var Cells : array[1..MaxCells] of TCellData;

procedure LoadCellSet(const CellSetName : string);

implementation
uses sysutils, vdebug,rlglobal;

procedure CellQuery(const nkey,nvalue : string);
var Key    : string;
    Number : Word;
begin
  Key := nkey;
  Delete(Key,1,4);
  Number := StrToInt(Key);
  if Number = 0 then CritError('Bad cell in CellSet : "'+nKey+'"');
  Cells[Number].id := nValue;
end;


procedure LoadCellSet(const CellSetName : string);
var Key    : string;
    Number : Word;
begin
  for Number := 1 to MaxCells do Cells[Number].id := '';
  if not Database.TrySetSection(CellsetName) then CritError('Cell set "'+CellSetName+'" not found!');
  Database.QuerySection(@CellQuery);

  for Number := 1 to MaxCells do
    if Cells[Number].id <> '' then
    with Cells[Number] do
    begin
      if not Database.TrySetSection(id) then CritError('Cell "'+id+'" not found!');
      color := Database.GetNumber('color');
      pic   := Database.GetString('pic')[1];
      pass  := Database.GetBoolean('passable');
      bvis  := Database.GetBoolean('blockvision');
      canch := Database.GetBoolean('canchange');
      name  := Database.GetString('name');
      if Database.Defined('activates') then actto := Database.GetNumber('activates') else actto := 0;
      if Database.Defined('special') then special := Database.GetNumber('special') else special := 0;
    end;
end;


end.

