unit rllua;
{$mode objfpc}{$H+}
interface

uses SysUtils, vlua, vluaio;

var LuaPlayerX : Byte = 2;
    LuaPlayerY : Byte = 2;


type

{ TRLLua }

TRLLua = class(TLua)
       constructor Create; override;
       procedure LuaError;
     end;

implementation

uses lua, lauxlib, crt, vdebug, vmath, voutput, vinput, rlglobal, rlmsg, rlgame, diablout;

{ TRLLua }

function lua_data(L: Plua_State): Integer; cdecl;
var num : DWord;
    arg : string;
begin
  if lua_gettop(L) = 0 then Exit(0);
  arg := UpCase(lua_tostring(L, 1));
  if ScriptData.Exists(arg) then
    num := ScriptData[arg]
  else
    num := 0;
  lua_pushnumber(L,num);
  Log('Data['+arg+'] == '+IntToStr(num));
  Result := 1;
end;

function lua_setdata(L: Plua_State): Integer; cdecl;
var num : DWord;
    arg : string;
begin
  if lua_gettop(L) < 2 then Exit(0);
  arg := UpCase(lua_tostring(L, 1));
  num := Round(lua_tonumber(L, 2));
  ScriptData[arg] := num;
  Log('Data['+arg+'] := '+IntToStr(num));
  Result := 0;
end;


function lua_msg(L: Plua_State): Integer; cdecl;
begin
  if lua_gettop(L) = 0 then Exit(0);
  Msg.Add(lua_tostring(L, 1));
  Result := 0;
end;

function lua_enter(L: Plua_State): Integer; cdecl;
begin
  Input.GetKey([VKEY_Enter,Ord(' ')]);
  Result := 0;
end;

function lua_delay(L: Plua_State): Integer; cdecl;
begin
  Delay(ByteOrDef(L,1,1));
  Result := 0;
end;

function lua_endgame(L: Plua_State): Integer; cdecl;
begin
  GameEnd := true;
  Game.Player.WriteMemorial;
  Result := 0;
end;

function lua_msgenter(L: Plua_State): Integer; cdecl;
begin
  if lua_gettop(L) = 0 then Exit(0);
  Msg.Add(lua_tostring(L, 1)+' Press <Enter>...');
  Msg.Draw; Output.Update;
  Input.GetKey([VKEY_Enter]);
  Result := 0;
end;

function lua_msgconfirm(L: Plua_State): Integer; cdecl;
begin
  if lua_gettop(L) = 0 then Exit(0);
  Msg.Add(lua_tostring(L, 1)+' [y/n]');
  Msg.Draw; Output.Update;
  lua_pushboolean(L,Input.GetKey([Ord('Y'),Ord('y'),Ord('N'),Ord('n')]) in [Ord('Y'),Ord('y')]);
  Result := 1;
end;

// ************************************************************************ //
// ************************************************************************ //

function lua_random(L: Plua_State): Integer; cdecl;
begin
  if lua_gettop(L) < 1 then Exit(0);
  lua_pushnumber(L,Random(WordOrDef(L,1,0)));
  Result := 1;
end;

function lua_plottalk(L: Plua_State): Integer; cdecl;
var Window : TWindow;
begin
  Window := TWindow.Init(6,3,74,22,DiabloStyle);
  Window.Show;
  Window.Draw;

  Output.DrawString(8,5,YELLOW,lua_tostring(L,1),66);

  Output.Update;
  Input.GetKey([VKEY_ESCAPE,VKEY_ENTER]);
  FreeAndNil(Window);
  Result := 0;
end;

function lua_shoppepin(L: Plua_State): Integer; cdecl;
begin
  Result := 0;
  DiabloPepinShop;
end;

function lua_shopgriswold(L: Plua_State): Integer; cdecl;
begin
  Result := 0;
  DiabloGriswoldShop;
end;


procedure TRLLua.LuaError;
begin
  Msg.Add('LuaError: '+ErrorStr);
end;


constructor TRLLua.Create;
var cn : byte;
    SearchRec : TSearchRec;
begin
  inherited Create;

  LoadLuaIO(LuaState);
//  AddVar('VERSION',Version);
  Register('msg',@lua_msg);
  Register('msgenter',@lua_msgenter);
  Register('msgconfirm',@lua_msgconfirm);
  Register('enter',@lua_enter);
  Register('random',@lua_random);
  Register('delay',@lua_delay);
  Register('data',@lua_data);
  Register('setdata',@lua_setdata);
  Register('endgame',@lua_endgame);
  Register('plottalk',@lua_plottalk);
  Register('shoppepin',@lua_shoppepin);
  Register('shopgriswold',@lua_shopgriswold);

  if FindFirst('lua' + PathDelim + '*.lua',faAnyFile,SearchRec) = 0 then
  repeat
     Lua_doFile(LuaState,PChar(Ansistring('lua' + PathDelim + SearchRec.Name)));
  until (FindNext(SearchRec) <> 0);
  FindClose(SearchRec);
end;


end.

