unit rlmsg;
interface
uses voutput, vsystem, rlglobal;

const MsgMaxX = 78;

type TMessageField = class(TSystem)
                       Mem1,Mem2 : string[78];
                       Fresh     : Boolean;
                       Number    : DWord;
                       constructor Create; override;
                       procedure Add(s : string);
                       procedure Update;
                       procedure Clear;
                       procedure Draw;
                       destructor Destroy; override;
                     end;

const Msg : TMessageField = nil;

implementation

constructor TMessageField.Create;
begin
  inherited Create;
  Mem1 := '';
  Mem2 := '';
  Fresh := False;
  Number := 0;
end;

procedure TMessageField.Clear;
begin
  Mem1 := '';     Mem2 := '';
  Fresh := False; Number := 0;
  Draw;
end;


procedure TMessageField.Add(s : string);
begin
  //RunMode := False;
  Inc(Number);
  if Fresh = False then begin
                          Mem1 := s; Mem2 := '';
                          Fresh := True;
                          Draw; Exit; end;
  if Mem2 <> '' then
    begin
      if Length(Mem2)+Length(s) < MsgMaxX-1 then
         Mem2 := Mem2  + ' ' + s
             else begin
                    Output.DrawString(MsgMaxX-6,2,LightBlue+128,'[more]');
                    Output.Update;
                    Mem1 := s;
                    Mem2 := '';
                  end;
      Draw; Exit;
    end
  else
    begin
      if Length(Mem1)+Length(s) < MsgMaxX-1 then
                  Mem1 := Mem1 + ' ' + s
             else Mem2 := s;
      Draw;
    end;
end;

procedure TMessageField.Draw;
begin
  Output.DrawString(2,1,LightGray,'                                                                              ');
  Output.DrawString(2,2,LightGray,'                                                                              ');
  if Fresh then
  begin
    Output.DrawString(2,1,LightGray,Mem1);
    Output.DrawString(2,2,LightGray,Mem2);
  end
  else
  begin
    Output.DrawString(2,1,DarkGray,Mem1);
    Output.DrawString(2,2,DarkGray,Mem2);
  end;
end;

procedure TMessageField.UpDate;
begin
  Fresh  := False;
  Draw;
  Number := 0;
end;


destructor TMessageField.Destroy;
begin
  inherited Destroy;
end;

end.

