// @abstract(Valkyrie Flag Types)
// @author(Kornel Kisielewicz <kisiel@fulbrightweb.org>)
// @created(1 June, 2004)
// @lastmod(1 June, 2004)

unit vflags;
interface

procedure SetBFlag(var b : byte; pos: byte);
procedure MultiSetBFlag(var b : byte; pos: array of byte);
procedure ClearBFlag(var b : byte; pos: byte);
procedure MultiClearBFlag(var b : byte; pos: array of byte);
function FlagSet(b : word; pos: byte):boolean;

{** Bit Constants **}
const bit : array[0..15] of Word =
           (    1,    2,    4,    8,   16,   32,   64,  128,
              256,  512, 1024, 2048, 4096, 8192,16384,32768);

implementation

function FlagSet(b : word; pos: byte):boolean;
begin
  FlagSet := False;
  if b and bit[pos] = bit[pos] then FlagSet := true;
end;

procedure SetBFlag(var b : byte; pos: byte);
begin
  b := b or bit[pos];
end;

procedure MultiSetBFlag(var b : byte; pos: array of byte);
var c : byte;
begin
  for c := Low(pos) to High(pos) do
    b := b or bit[pos[c]];
end;

procedure ClearBFlag(var b : byte; pos: byte);
begin
  b := b and not bit[pos];
end;

procedure MultiClearBFlag(var b : byte; pos: array of byte);
var c : byte;
begin
  for c := Low(pos) to High(pos) do
    b := b and not bit[pos[c]];
end;

end.

